;; getty.scm -- consoles login daemons

(define getty (cat sbin-dir "getty"))

(define getty2-service (service '(getty2)
    #:requirement '(single-user)
    #:start (lambda args
	      (if (file-exists? "/dev/tty2")
		  (begin
		    (boot-format "[....] Starting getty on tty2...")
		    (let ((ret ((make-forkexec-constructor (list getty "38400" "tty2")))))
		      (if ret
			  (begin
			    (boot-format-ok)
			    ret)
			  (begin
			    (boot-format-fail)
			    #f))))
		  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    ))

(register-services (list getty2-service))

(define getty3-service (service '(getty3)
    #:requirement '(single-user)
    #:start (lambda args
	      (if (file-exists? "/dev/tty3")
		  (begin
		    (boot-format "[....] Starting getty on tty3...")
		    (let ((ret ((make-forkexec-constructor (list getty "38400" "tty3")))))
		      (if ret
			  (begin
			    (boot-format-ok)
			    ret)
			  (begin
			    (boot-format-fail)
			    #f))))
		  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    ))

(register-services (list getty3-service))

(define gettyUSB0-service (service '(gettyUSB0)
    #:requirement '(single-user)
    #:start (lambda args
	      (if (file-exists? "/dev/ttyUSB0")
		  (begin
		    (boot-format "[....] Starting getty on ttyUSB0...")
		    (let ((ret ((make-forkexec-constructor (list getty "9600" "ttyUSB0")))))
		      (if ret
			  (begin
			    (boot-format-ok)
			    ret)
			  (begin
			    (boot-format-fail)
			    #f))))
		  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services (list gettyUSB0-service))

;; the console for Xen
(define gettyhvc0-service (service '(gettyhvc0)
    #:requirement '(single-user)
    #:start (lambda args
              (if (file-exists? "/dev/hvc0")
		  (begin
		    (boot-format "[....] Starting getty on hvc0...")
		    (let ((ret ((make-forkexec-constructor (list getty "38400" "hvc0")))))
		      (if ret
			  (begin
			    (boot-format-ok)
			    ret)
			  (begin
			    (boot-format-fail)
			    #f))))
                  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services (list gettyhvc0-service))

;; some ARM devices
(define gettymxc0-service (service '(gettymxc0)
    #:requirement '(single-user)
    #:start (lambda args
              (if (file-exists? "/dev/ttymxc0")
		  ;; as this is a real serial port, we keep the current baud rate
                  (let ((sp (system-value* "/usr/bin/stty" "-F" "/dev/ttymxc0" "speed")))
		    (boot-format "[....] Starting getty on ttymxc0...")
		    (let ((ret ((make-forkexec-constructor (list getty sp "ttymxc0")))))
		      (if ret
			  (begin
			    (boot-format-ok)
			    ret)
			  (begin
			    (boot-format-fail)
			    #f))))
                  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services (list gettymxc0-service))

