;; NetworkManager.scm -- NetworkManager daemon

(define NM (cat usr-sbin-dir "NetworkManager"))

(define NetworkManager-service
  (service '(NetworkManager)
    #:requirement '(networking)
     #:start (lambda args
	      (if (file-exists? NM)
		  (begin
		    (boot-format "[....] Starting NetworkManager...")
		    (let ((ret ((make-forkexec-constructor (list NM "--no-daemon")))))
		      (if ret
			  (begin
			    (boot-format-ok)
			    ret)
			  (begin
			    (boot-format-fail)
			    #f))
		      ))
		  #f))
    #:stop (lambda (running)
	     (when running
		   (boot-format "[....] Stopping NetworkManager...")
		   (catch-system-error (kill (process-id running) SIGTERM))
		   (boot-format-ok))
	     #f)
    ))

(register-services (list NetworkManager-service))
