;; anacron.scm -- anacron script

(define anacron (cat usr-sbin-dir "anacron"))

(define anacron-service
  (service '(anacron)
    #:requirement '(cron)
    #:start (lambda args
	      (if (file-exists? anacron)
		  (begin
		    (boot-format "[....] Starting anacron...")
		    (if ((make-forkexec-constructor (list anacron "-s")))
			(begin
			  (boot-format-ok)
			  #t)
			(begin
			  (boot-format-fail)
			  #f)
			))
		  #f))
    #:stop (lambda (running)
	     (when (file-exists? anacron)
	       ;; anacron runs only from time to time, so kill it when it happens at reboot/shutdown time
	       (boot-format "[....] Stopping anacron...")
	       ;; TODO: kill children
	       (killall anacron)
	       (boot-format-ok))
	     #f)
    ))

(register-services (list anacron-service))
