;; bluetooth.scm -- bluetooth daemon

(define bluetoothd (cat usr-sbin-dir "bluetoothd"))

(define bluetooth-service
  (service '(bluetooth)
    #:requirement '(dbus)
    #:start (lambda args
	      (if (file-exists? bluetoothd)
		  (begin
		    (boot-format "[....] Starting bluetoothd...")
		    (let ((pid ((make-forkexec-constructor (list bluetoothd)))))
		      (if pid
			  (begin
			    (boot-format-ok)
			    pid)
			  (begin
			    (boot-format-fail)
			    #f)
			  )))
		  #f))
    #:stop (lambda (running)
	     (when running
		   (boot-format "[....] Stopping bluetoothd...")
		   (catch 'system-error
			  (lambda ()
			    (kill (process-id running) SIGTERM)
			    (boot-format-ok))
			  (lambda (key . args) (boot-format-fail))))
	     #f)
    ))

(register-services (list bluetooth-service))

