;; cron.scm -- cron daemon

(define cron (cat usr-sbin-dir "cron"))

;; current cron has that built in, but it is not documented
(define cron-pidfile "/var/run/crond.pid")

(define cron-service
  (service '(cron)
    #:requirement '(single-user)
    #:start (lambda args
	      (if (file-exists? cron)
		  (begin
		    (boot-format "[....] Starting cron...")
		    (if ((make-forkexec-constructor (list cron)))
			(begin
			  (boot-format-ok)
			  #t)
			(begin
			  (boot-format-fail)
			  #f)
			))
		  #f))
    #:stop (lambda (running)
	     (when (and running (file-exists? cron-pidfile))
		   (boot-format "[....] Stopping cron...")
		   (let ((pid (with-input-from-file cron-pidfile read)))
		     (delete-file cron-pidfile)
		     (catch-system-error (kill pid SIGTERM)))
		   (boot-format-ok))
	     #f)
    ))

(register-services (list cron-service))
