;; dhcpcd.scm -- dhcpcd daemon

(define dhcpcd (cat usr-sbin-dir "dhcpcd"))

(define dhcpcd-piddir "/var/run/dhcpcd")
(define dhcpcd-pidfile (cat dhcpcd-piddir "/pid"))

(define dhcpcd-service
  (service '(dhcpcd)
    #:requirement '(networking)
    #:start (lambda args
	      (if (file-exists? dhcpcd)
		  (begin
		    (boot-format "[....] Starting dhcpcd...")
		    (if ((make-forkexec-constructor (list dhcpcd "-b") #:pid-file dhcpcd-pidfile))
			(begin
			  (boot-format-ok)
			  #t)
			(begin
			  (boot-format-fail)
			  #f)
			))
		  #f))
    #:stop (lambda (running)
	     (when (and running (file-exists? dhcpcd-pidfile))
	       (boot-format "[....] Stopping dhcpcd...")
	       (let ((pid (with-input-from-file dhcpcd-pidfile read)))
		 (delete-file dhcpcd-pidfile)
		 (catch-system-error (kill pid SIGTERM)))
	       (boot-format-ok))
	     #f)
    ))

(register-services (list dhcpcd-service))
