;; fullnetwork.scm -- virtual service, ensuring that all network interfaces
;; (vpn, ppp...) are started if they exist

(define fullnetwork-service
  (service '(fullnetwork)
    #:requirement '(rsyslogd)
    ;; assumes we don't do fancy stuff like remote syslog through a tunnel
    #:start (lambda args
	      (let ((serv (lookup-service 'openvpn)))
		(when serv
		  (start-service serv)))
	      #t)
    #:stop (lambda (running)
	     (let ((serv (lookup-service 'openvpn)))
	       (when serv
		 (stop-service serv)))
	     #f)
    ))

(register-services (list fullnetwork-service))
